//=============================================================================
// PistolPickup
// Copyright 2001 Running With Scissors, Inc.  All Rights Reserved.
//
// Pistol weapon pickup.
//
//	History:
//		01/29/02 MJR	Started history, probably won't be updated again until
//							the pace of change slows down.
//
//=============================================================================

class GoldenGunPickup extends P2WeaponPickup;

function AnnouncePickup(pawn Receiver)
{
	Super.AnnouncePickup(Receiver);
	BroadcastLocalizedMessage(class'GunMessages', 0, Receiver.PlayerReplicationInfo, None, None );
}

function float BotDesireability( pawn Bot )
{
	return MaxDesireability;
}

state Pickup
{
Begin:
	sleep(5);
	spawn(class'FX.SparkHitProjectile',self,,location);
	Goto('Begin');
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
	{
	AmmoGiveCount=666
	MPAmmoGiveCount=666
	DeadNPCAmmoGiveRange=(Min=2,Max=5)
	InventoryType=class'GoldenGunWeapon'
	ShortSleeveType=class'GoldenGunWeaponSS'
	PickupMessage="You picked up the Golden Gun!"
	DrawType=DT_StaticMesh
	StaticMesh=StaticMesh'GGMesh.GoldenGun'
	CollisionRadius=40.000000
	CollisionHeight=5.000000
	BounceSound=Sound'MiscSounds.PickupSounds.gun_bounce'
	bAllowedToRespawn=false
	RespawnTime=0.000000
	}
