class GoldenGunWeapon extends PistolWeapon;

replication
{
	reliable if (ROLE==ROLE_Authority)
		ForceSwitch;
}

function DropFrom(vector StartLocation)
{
	BroadcastLocalizedMessage(class'GunMessages', 1, Pawn(Owner).PlayerReplicationInfo, None, None );	
	Super.DropFrom(StartLocation);
}

simulated function Fire(float Value)
{
	spawn(class'GoldenFirePillar',Self,,Instigator.Location);
	Super.Fire(Value);
}

simulated function ForceSwitch(PlayerController pc)
{
	pc.GetWeapon(class'GoldenGunWeapon');
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
simulated function PickupFunction(Pawn Other)
{
	Super.PickupFunction(Other);
	if (P2Pawn(Other) != None) {
		if (PlayerController(Other.Controller) != None && ROLE==ROLE_Authority) {
			ForceSwitch(PlayerController(Other.Controller));
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
	{
	ItemName="GoldenGun"
	PickupClass=class'GoldenGunPickup'
	AmmoName=class'GoldenGunAmmoInv'
	AttachmentClass=class'GoldenGunAttachment'
	Skins[1]=Texture'GGTex.GoldenGun'
	GroupOffset=2
	CombatRating=5.0
	AIRating=1.0
	ViolenceRank=MAX_VIOLENCE_RANK
	}
