//
// Gun Messages
//
// Switch 0: Pickup Message
//	RelatedPRI_1 is the player who picked up the gun.
//
// Switch 1: Drop Message
//	RelatedPRI_1 is the player who dropped the gun.
// Switch 2: Find the Golden Gun!

class GunMessages extends CriticalEventPlus;

var(Message) localized string PickupString;
var(Message) localized string DropString;
var(Message) localized string FindGunString;

static function string GetString(
	PlayerController P,
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{
	local int YouOrThem;

	if (MpPlayer(P) != None &&
		P.PlayerReplicationInfo != None )
	{
		switch (Switch)
		{
			// Gun picked up
			case 0:
				if (RelatedPRI_1 == None)
					return "";
				return RelatedPRI_1.PlayerName @ Default.PickupString;
				break;

			// Gun dropped.
			case 1:
				if (RelatedPRI_1 == None)
					return "";
				return RelatedPRI_1.PlayerName @ Default.DropString;
				break;

			// Find the gun!
			case 2:
				return Default.FindGunString;
				break;
		}
	}
	return "";
}

defaultproperties
{
	PickupString="picked up the Golden Gun!"
	DropString="dropped the Golden Gun!"
	FindGunString="Find the Golden Gun!"
}