class MapShuffleRules extends GameRules
	config(kMods);

var config int MapHistoryLength;
var config bool bUseListLength;
var config array<string>LastFewMaps;

// HandleRestartGame
// Copied from MpGameInfo

function int MapListLength(MapList foo)
{
	local int i, j;

	j = 0;
	for (i=0;i<ArrayCount(foo.Maps); i++)
		if (foo.Maps[i] != "")
			j++;

	return j;
}

function bool PlayedMap(string bar)
{
	local int i;
	local bool bFoo;

	for (i=0;i<LastFewMaps.Length;i++)
		if (LastFewMaps[i] ~= bar)
			bFoo=true;

	return bFoo;
}

function string GetRandomMap(MapList foo)
{
	local string CurrentMap;
	local int i,j,k,count;

	CurrentMap = GetURLMap();

	LastFewMaps.Insert(0,1);
	LastFewMaps[0]=CurrentMap;

	if ( CurrentMap != "" )
	{
		if ( Right(CurrentMap,4) ~= ".fuk" )
			CurrentMap = CurrentMap;
		else
			CurrentMap = CurrentMap$".fuk";

		for ( i=0; i<ArrayCount(foo.Maps); i++ )
		{
			if ( CurrentMap ~= foo.Maps[i] )
				break;
		}
	}

	// search vs. w/ or w/out .fuk extension

	k = MapListLength(foo);
	if (bUseListLength || MapHistoryLength > MapListLength(foo))
		MapHistoryLength=MapListLength(foo)-1;
	if (MapHistoryLength < 0)
		MapHistoryLength=0;
	LastFewMaps.Length=MapHistoryLength;

	j = i;
	count = 0;
	while ((j == i || foo.Maps[j] == "" || PlayedMap(foo.Maps[j])) && count < 5000)
	{
		j = Rand(ArrayCount(foo.Maps)+1);
		count++;
	}

	if (foo.Maps[j] == "")
		j = 0;

	SaveConfig();
	return foo.Maps[j];
}

function bool HandleRestartGame()
{
	local MapList MyList;
	local string NextMap;

	// let other gamerules do their thing
	if ( (NextGameRules != None) && NextGameRules.HandleRestartGame() )
		return true;


	// don't restart if already restarted
	if ( Level.Game.bGameRestarted )
		return false;

	// these server travels should all be relative to the current URL
	if ( Level.Game.bChangeLevels && !Level.Game.bAlreadyChanged && (Level.Game.MapListType != "") )
	{
		// open a the nextmap actor for this game type and get the next map
		Level.Game.bAlreadyChanged = true;
		MyList = Level.Game.GetMapList(Level.Game.MapListType);

		if (MyList != None)
		{
			NextMap = GetRandomMap(MyList);
			MyList.Destroy();
		}
		if ( NextMap != "" )
		{
			Level.ServerTravel(NextMap, false);
			Level.Game.bGameRestarted = true;
			return true;
		}
	}

	return false;
}

defaultproperties
{
	MapHistoryLength=10
	bUseListLength=true
}