///////////////////////////////////////////////////////////////////////////////
// MutExpertMode.uc
// postaldude@cox.net
//
// Starts with all weapons and max ammo
//
///////////////////////////////////////////////////////////////////////////////
class MutExpertMode extends MutLoaded
	config(kMods);

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	if (P2AmmoInv(Other) != None)
		P2AmmoInv(Other).AmmoAmount=P2AmmoInv(Other).MaxAmmoMP;
	if (P2WeaponPickup(Other) != None)
		return false;
	if (P2AmmoPickup(Other) != None)
		return false;
	if (DonutPickup(Other) != None)
		return false;
	if (FastFoodPickup(Other) != None)
		return false;
	if (CrackPickup(Other) != None)
		return false;
	if (MedkitPickup(Other) != None)
		return false;

	return Super.CheckReplacement(Other, bSuperRelevant);
}

function ModifyPlayer(pawn Other)
{
	local CrackInv crack;
	local P2Pawn p2p;

	Super.ModifyPlayer(Other);

	crack=spawn(class'CrackInv');
	Other.AddInventory(crack);
	if (P2Pawn(Other) != None)
		p2Pawn(Other).AddArmor(100,Texture(class'KevlarInv'.Default.Icon),class'KevlarInv');
}

defaultproperties
{
	GroupName="Loaded"
	FriendlyName="Expert Mode"
	Description="Players start with all weapons, max ammo, 125 health, kevlar, and a crack pipe. All health, weapon, and ammo pickups are disabled."
}
