///////////////////////////////////////////////////////////////////////////////
// MutLotsOfAmmo.uc
// postaldude@cox.net
//
// Alters ammo maximums for weapons
//
///////////////////////////////////////////////////////////////////////////////
class MutLotsOfAmmo extends xMutator
	config(kMods);

var config int PistolMax;
var config int MolotovMax;
var config int CowHeadMax;
var config int GrenadeMax;
var config int LauncherMax;
var config int MachineGunMax;
var config int RifleMax;
var config int ScissorsMax;
var config int ShotgunMax;

///////////////////////////////////////////////////////////////////////////////
// Raise max ammo now
///////////////////////////////////////////////////////////////////////////////
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	if (PistolBulletAmmoInv(Other) != None)
		PistolBulletAmmoInv(Other).MaxAmmoMP=PistolMax;
	if (MolotovAmmoInv(Other) != None)
		MolotovAmmoInv(Other).MaxAmmoMP=MolotovMax;
	if (CowHeadAmmoInv(Other) != None)
		CowHeadAmmoInv(Other).MaxAmmoMP=CowheadMax;
	if (GrenadeAmmoInv(Other) != None)
		GrenadeAmmoInv(Other).MaxAmmoMP=GrenadeMax;
	if (LauncherAmmoInv(Other) != None)
		LauncherAmmoInv(Other).MaxAmmoMP=LauncherMax;
	if (MachineGunBulletAmmoInv(Other) != None)
		MachineGunBulletAmmoInv(Other).MaxAmmoMP=MachineGunMax;
	if (RifleAmmoInv(Other) != None)
		RifleAmmoInv(Other).MaxAmmoMP=Riflemax;
	if (ScissorsAmmoInv(Other) != None)
		ScissorsAmmoInv(Other).MaxAmmoMP=ScissorsMax;
	if (ShotgunBulletAmmoInv(Other) != None)
		ShotGunBulletAmmoInv(Other).MaxAmmoMP=ShotgunMax;
	return true;
}

defaultproperties
{
	GroupName="kAmmoMod"
	FriendlyName="Mega Ammo Mode"
	Description="Extends max ammo for all weapons."
	PistolMax=1000
	MolotovMax=40
	CowHeadMax=8
	GrenadeMax=80
	LauncherMax=300
	MachineGunMax=400
	RifleMax=16
	ScissorsMax=98
	ShotgunMax=80
}
