///////////////////////////////////////////////////////////////////////////////
// MutMPWeapons.uc
// postaldude@cox.net
//
// Disables those annoying non-working weapons like WMD
//
///////////////////////////////////////////////////////////////////////////////
class MutMPWeapons extends xMutator;

///////////////////////////////////////////////////////////////////////////////
// Check to replace WMDs, etc.
///////////////////////////////////////////////////////////////////////////////
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	// Check normal pickups
	if(PlaguePickup(Other) != None || NapalmPickup(Other) != None)
	{
		ReplaceWith(Other, "Inventory.LauncherPickup");
		return false;
	}
	if(GasCanPickup(Other) != None)
	{
		ReplaceWith(Other, "Inventory.MolotovPickup");
		return false;
	}
	if(ShockerPickup(Other) != None)
	{
		ReplaceWith(Other, "Inventory.GrenadePickup");
		return false;
	}
	if(PlagueAmmoPickup(Other) != None || NapalmAmmoPickup(Other) != None)
	{
		ReplaceWith(Other, "Inventory.LauncherAmmoPickup");
		return false;
	}
	// Remove also from cycling pickups
	else if(MultiPickup(Other) != None)
	{
		MultiPickup(Other).SwapClass(class'PlaguePickup', class'LauncherPickup');
		MultiPickup(Other).SwapClass(class'NapalmPickup', class'LauncherPickup');
		MultiPickup(Other).SwapClass(class'GasCanPickup', class'MolotovPickup');
		MultiPickup(Other).SwapClass(class'ShockerPickup', class'GrenadePickup');
		MultiPickup(Other).SwapClass(class'PlagueAmmoPickup', class'LauncherAmmoPickup');
		MultiPickup(Other).SwapClass(class'NapalmAmmoPickup', class'LauncherAmmoPickup');
	}

	return true;
}

defaultproperties
{
     GroupName="Clean MP Mode"
     FriendlyName="MP-Friendly Weapons"
     Description="Replaces weapons that don't work properly in multiplayer mode with MP-friendly weapons."
}
