///////////////////////////////////////////////////////////////////////////////
// MutNoHealth.uc
// postaldude@cox.net
//
// Turns off health powerups, makes for an interesting game
//
///////////////////////////////////////////////////////////////////////////////
class MutNoHealth extends xMutator;

///////////////////////////////////////////////////////////////////////////////
// Make all weapons super strong (also, explosions, fire, projectiles, etc)
///////////////////////////////////////////////////////////////////////////////
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	// Check normal pickups
	if(DonutPickup(Other) != None || PizzaPickup(Other) != None || FastfoodPickup(Other) != None || CrackPickup(Other) != None || MedkitPickup(Other) != None)
		return false;
	// Remove also from cycling pickups
	else if(MultiPickup(Other) != None)
	{
		MultiPickup(Other).SwapClass(class'DonutPickup', class'PistolAmmoPickup');
		MultiPickup(Other).SwapClass(class'PizzaPickup', class'PistolAmmoPickup');
		MultiPickup(Other).SwapClass(class'FastFoodPickup', class'PistolAmmoPickup');
		MultiPickup(Other).SwapClass(class'CrackPickup', class'PistolAmmoPickup');
		MultiPickup(Other).SwapClass(class'MedKitPickup', class'PistolAmmoPickup');
	}

	return true;
}

defaultproperties
{
     GroupName="kHealthMod"
     FriendlyName="No Health"
     Description="Turns off health pickups for a deadly game."
}
