///////////////////////////////////////////////////////////////////////////////
// MutOnlyNoSeekers.uc
// postaldude@cox.net
//
// Change all weapons to foo
//
///////////////////////////////////////////////////////////////////////////////
class MutOnlyNoSeekers extends xMutator;

// Base mutator for weapon substitution.
// Easy to make your own weapon subs... all shovel if you want, or all WMD, or whatever.

///////////////////////////////////////////////////////////////////////////////
// Replace weapons with foo
///////////////////////////////////////////////////////////////////////////////
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	// Check normal pickups
	if (P2WeaponPickup(Other) != None && Other.Class != class'kStandardLauncherPickup')
		return !ReplaceWith(Other, "NoSeekers.kStandardLauncherPickup");
	if (P2AmmoPickup(Other) != None && Other.Class != class'LauncherAmmoPickup')
		return !ReplaceWith(Other, "Inventory.LauncherAmmoPickup");

	// Replace default pistol with foo
	if (PistolWeaponSS(Other) != None && P2Pawn(Other.Owner) != None)
		return (P2Pawn(Other.Owner).CreateInventoryByClass(class'kStandardLauncherSS') == None);
	if (PistolWeapon(Other) != None && P2Pawn(Other.Owner) != None)
		return (P2Pawn(Other.Owner).CreateInventoryByClass(class'kStandardLauncher') == None);

	// Remove also from cycling pickups
	if(MultiPickup(Other) != None)
	{
		MultiPickup(Other).SwapClass(class'CowHeadPickup', class'kStandardLauncherPickup');
		MultiPickup(Other).SwapClass(class'ScissorsPickup', class'kStandardLauncherPickup');
		MultiPickup(Other).SwapClass(class'LauncherPickup', class'kStandardLauncherPickup');
		MultiPickup(Other).SwapClass(class'LauncherAmmoPickup', class'LauncherAmmoPickup');
		MultiPickup(Other).SwapClass(class'MachinegunPickup', class'kStandardLauncherPickup');
		MultiPickup(Other).SwapClass(class'MachinegunAmmoPickup', class'LauncherAmmoPickup');
		MultiPickup(Other).SwapClass(class'MolotovPickup', class'kStandardLauncherPickup');
		MultiPickup(Other).SwapClass(class'RiflePickup', class'kStandardLauncherPickup');
		MultiPickup(Other).SwapClass(class'RifleAmmoPickup', class'LauncherAmmoPickup');
		MultiPickup(Other).SwapClass(class'ShotgunPickup', class'kStandardLauncherPickup');
		MultiPickup(Other).SwapClass(class'ShotgunAmmoPickup', class'LauncherAmmoPickup');
	}

	// Alter max ammo of Grenades
	if (P2AmmoInv(Other) != None)
		if (P2AmmoInv(Other).Class == class'LauncherAmmoInv')
			P2AmmoInv(Other).MaxAmmoMP = P2AmmoInv(Other).Default.MaxAmmoMP * 3;

	return true;
}

defaultproperties
{
	GroupName="kWeaponPickupReplacement"
	FriendlyName="Only: Non-seeking Rockets"
	Description="Substitutes all weapons in the game with non-seeking rockets."
}
