class SafeSpawnRules extends GameRules
	config(kMods);

var config int MaxCheckDist;

var bool bRandom;

function PostBeginPlay()
{
	if (TeamGame(Level.Game) != None)
		if (TeamGame(Level.Game).bSpawnInTeamArea)
			bRandom=false; // don't use random playerstarts in CTF games
	//log(self@"was added, bRandom is"@bRandom);
}

function float RatePlayerStart(NavigationPoint N, byte Team, Controller Player)
{
	local PlayerStart PS;
	local float Score, MinDist;
	local int HazardCount;
	local Pawn P;
	local P2Projectile P2Proj;
	local WEmitter W;

	PS = PlayerStart(N);
	if (PS == None)
		if (!bRandom)
			return -10000000;
	if (TeamGame(Level.Game) != None)
		if (TeamGame(Level.Game).bSpawnInTeamArea)
			if (Team != PS.TeamNumber)
				return -9999999;

	HazardCount=0;
	MinDist=999999;
	foreach RadiusActors(class'Pawn', P, MaxCheckDist, N.Location)
	{
		HazardCount++;
		if (VSize(N.Location - P.Location) < MinDist)
			MinDist=VSize(N.Location-P.Location);
	}
	foreach RadiusActors(class'P2Projectile', P2Proj, MaxCheckDist, N.Location)
	{
		HazardCount++;
		if (VSize(N.Location - P2Proj.Location) < MinDist)
			MinDist=VSize(N.Location-P2Proj.Location);
	}
	foreach RadiusActors(class'WEmitter', W, MaxCheckDist, N.Location)
	{
		HazardCount++;
		if (VSize(N.Location - W.Location) < MinDist)
			MinDist=VSize(N.Location-W.Location);
	}

	if (HazardCount > 0)
		Score = MinDist/HazardCount;
	else
		Score = 500000 + 3000*FRand();

	//log(self@"gave a spawn rating of"@score@"to"@n);
	return Score;
}

function NavigationPoint FindPlayerStart( Controller Player, optional byte InTeam, optional string incomingName )
{
	local NavigationPoint N, BestStart;
	local Teleporter Tel;
	local float BestRating, NewRating;
	local byte Team;

	// if incoming start is specified, then just use it
	if( incomingName!="" )
		foreach AllActors( class 'Teleporter', Tel )
			if( string(Tel.Tag)~=incomingName )
				return Tel;

	// use InTeam if player doesn't have a team yet
	if ( (Player != None) && (Player.PlayerReplicationInfo != None) )
	{
		if ( Player.PlayerReplicationInfo.Team != None )
			Team = Player.PlayerReplicationInfo.Team.TeamIndex;
		else
			Team = 0;
	}
	else
		Team = InTeam;

	for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
	{
		NewRating = RatePlayerStart(N,InTeam,Player);
		if ( NewRating > BestRating )
		{
			BestRating = NewRating;
			BestStart = N;
		}
	}

	if (BestStart == None)
		if ( NextGameRules != None )
			return NextGameRules.FindPlayerStart(Player,InTeam,incomingName);

	return BestStart;
}

defaultproperties
{
	bRandom=false
	MaxCheckDist=5000
}