class kAdmin extends Admin;
// Whisper (talk to) command
// Change player's names
// Restrict different weapons

var array<vector> TeleSpots;

function FillTeleSpots()
{
	local PlayerStart foo;

	if (Telespots.Length>0)
		TeleSpots.Remove(0,TeleSpots.Length);
	foreach AllActors(class'PlayerStart', foo)
	{
		Telespots.Insert(0, 1);
		TeleSpots[0] = foo.Location;
	}
}

static final operator(24) bool isin(string a, string b)
{
	return (InStr(caps(b), caps(a)) != -1);
}

exec function say(string Msg)
{
	Outer.Say("#" $ msg);
}

exec function ban(string s, optional float minutes)
{
	kP2Admin(Level.Game.AccessControl).Ban(s, minutes);
}

exec function unban(string s)
{
	kP2Admin(Level.Game.Accesscontrol).UnBan(s);
}

exec function llama(string S)
{
	local PlayerController P;
	local bool bFound;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	ForEach DynamicActors(class'PlayerController', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			kVoteHandler(Level.Game.BroadcastHandler).AddLlama(P);
			Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "has been llamafied!");
			P.PlayerReplicationInfo.PlayerName = "Llama";
			P.ClientMessage("You have been llamafied by the administrator! (You can still change your name, though.)");
			bFound=true;
		}
	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name.");
}

exec function unllama(string S)
{
	local PlayerController P;
	local bool bFound;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	ForEach DynamicActors(class'PlayerController', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			if (kVoteHandler(Level.Game.BroadcastHandler).DelLlama(P))
			{
				Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "has been de-llamafied.");
				P.ClientMessage("You were de-llamafied by the administrator. (You may change your name back if you haven't already.)");
			}
			else
				Outer.ClientMessage(S @ "is not a llama!");
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name.");
}

exec function mute(string S)
{
	local PlayerController P;
	local bool bFound;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}
	ForEach DynamicActors(class'PlayerController', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			kVoteHandler(Level.Game.BroadcastHandler).AddMute(P);
			Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "has been muted!");
			P.PlayerReplicationInfo.PlayerName = "Muted";
			P.ClientMessage("You have been muted by the administrator! (You can still change your name, though.)");
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name.");
}

exec function unmute(string S)
{
	local PlayerController P;
	local bool bFound;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	ForEach DynamicActors(class'PlayerController', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			if (kVoteHandler(Level.Game.BroadcastHandler).DelMute(P))
			{
				Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "has been unmuted.");
				P.ClientMessage("You were unmuted by the administrator. (You may change your name back if you haven't already.)");
			}
			else
				Outer.ClientMessage(S @ "is not mute!");
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name.");
}

exec function smite(string S)
{
	local Pawn P;
	local P2Pawn p2p;
	local bool bFound;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	ForEach DynamicActors(class'Pawn', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			if (PlayerController(P.Controller) != None)
				PlayerController(P.Controller).ClientMessage("You were smitten by the administrator!");
			p2p = P2Pawn(P);
			p2p.TakeDamage(9999,None,P.Location,Location,class'kSmittenDamage');
			p2p.ChunkUp(9999);
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name or that player is not currently alive.");
}

exec function teleport(string S)
{
	local Pawn P;
	local P2Pawn p2p;
	local vector Closet;
	local bool bFound;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	FillTeleSpots();

	ForEach DynamicActors(class'Pawn', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			Closet = P.Location;
			P.SetLocation(TeleSpots[Rand(TeleSpots.Length)]);
			spawn(class'kAdminTeleportEffects',,,Closet);
			Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "has been teleported to a random location.");
			if (PlayerController(P.Controller) != None)
				PlayerController(P.Controller).ClientMessage("You were teleported by the administrator!");
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name or that player is not currently alive.");

}

exec function cancelvote()
{
	local kVoteHandler vh;

	vh = kVoteHandler(Level.Game.BroadcastHandler);

	if (vh != None)
	{
		if (!vh.bVoteInProgress)
		{
			Outer.ClientMessage("No vote is currently in progress.");
			return;
		}
		vh.bVoteInProgress=false;
		vh.bVoteClosed=true;
		if (vh.OurReminder != None)
			vh.OurReminder.Destroy();
		vh.SystemMessage("Voting was ended forcefully by the administrator");
	}
}

exec function gravity(optional float Z)
{
	local PhysicsVolume pv;

	if (z == 0)
		z = 1500;

	z = -z;

	foreach DynamicActors(class'PhysicsVolume', pv)
		pv.gravity.z = z;

	level.game.broadcasthandler.broadcast(None,"Gravity set to" @ z);
}

exec function freeze(string S)
{
	local Pawn P;
	local P2Pawn p2p;
	local bool bFound;
	local kIceBlock ib;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	ForEach DynamicActors(class'Pawn', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			ib = spawn(class'kIceBlock');
			ib.Freeze(P);
			Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "has been frozen.");
			if (PlayerController(P.Controller) != None)
				PlayerController(P.Controller).ClientMessage("You were frozen by the administrator!");
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name or that player is not currently alive.");
}

exec function zero(string S)
{
	local Pawn P;
	local P2Pawn p2p;
	local bool bFound;
	local kIceBlock ib;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	ForEach DynamicActors(class'Pawn', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			P.PlayerReplicationInfo.Score = 0;
			Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "score zeroed.");
			if (PlayerController(P.Controller) != None)
				PlayerController(P.Controller).ClientMessage("You score was reset to 0 by the administrator.");
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name or that player is not currently alive.");
}

exec function neuter(string S)
{
	local Pawn P;
	local P2Pawn p2p;
	local bool bFound;
	local kIceBlock ib;
	local Inventory inv;
	local Vector TossVel;

	if (Len(S) < 3)
	{
		Outer.ClientMessage("Please specify at least 3 characters of the player name");
		return;
	}

	ForEach DynamicActors(class'Pawn', P)
		if ( s isin P.PlayerReplicationInfo.PlayerName )
		{
			P.bCanPickupInventory=false;
			P2Pawn(P).DestroyAllInventory();
			Outer.ClientMessage(P.PlayerReplicationInfo.PlayerName @ "has been neutered.");
			if (PlayerController(P.Controller) != None)
				PlayerController(P.Controller).ClientMessage("You were neutered by the administrator!");
			bFound=true;
		}

	if (!bFound)
		Outer.ClientMessage(S @ "is not a valid player name or that player is not currently alive.");
}
