///////////////////////////////////////////////////////////////////////////////
// ChemPillar
// 
// Pillar of chemical gas
//
///////////////////////////////////////////////////////////////////////////////
class kNukeMPPillar extends P2Emitter;

var bool bStopped;

const MOVE_TIME	=	0.25;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Active
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
auto state Active
{
/*	simulated function ProcessTouch(Actor Other, Vector HitLocation)
	{
		Stopping();
	}*/
	simulated function HitWall (vector HitNormal, actor Wall)
	{
		Stopping();
	}

	///////////////////////////////////////////////////////////////////////////////
	// Stop the pillar, but also make the top ball
	///////////////////////////////////////////////////////////////////////////////
	function Stopping()
	{
		local FireBall fp;
		if(!bStopped)
		{
			bStopped=true;
			Velocity.Z=0;
			// Top chemball
			spawn(class'kNukeMPBall',,,Location);
		}
	}
Begin:
	Sleep(MOVE_TIME);
	Stopping();
}

defaultproperties
{
    Begin Object Class=SuperSpriteEmitter Name=SuperSpriteEmitter14
		SecondsBeforeInactive=0.0
        UseColorScale=true
        ColorScale(0)=(RelativeTime=0.000000,Color=(B=50,G=150,R=150))
        ColorScale(1)=(RelativeTime=1.000000,Color=(B=150,G=50,R=255))
        MaxParticles=15
        RespawnDeadParticles=False
        StartLocationRange=(X=(Min=-30.000000,Max=30.000000),Y=(Min=-30.000000,Max=30.000000),Z=(Min=-30.000000,Max=30.000000))
        SpinParticles=True
		StartLocationOffset=(Z=-20.0)
        SpinsPerSecondRange=(X=(Max=0.100000))
        StartSpinRange=(X=(Max=1.000000))
        UseSizeScale=True
        UseRegularSizeScale=False
        SizeScale(0)=(RelativeTime=0.000000,RelativeSize=0.000000)
        SizeScale(1)=(RelativeTime=0.100000,RelativeSize=5.000000)
        SizeScale(2)=(RelativeTime=1.000000,RelativeSize=3.750000)
        StartSizeRange=(X=(Min=80.000000,Max=120.000000))
        InitialParticlesPerSecond=50.000000
        AutomaticInitialSpawning=False
        DrawStyle=PTDS_AlphaBlend
        Texture=Texture'nathans.Skins.smoke5'
        TextureUSubdivisions=1
        TextureVSubdivisions=4
        BlendBetweenSubdivisions=True
        LifetimeRange=(Min=3.500000,Max=5.000000)
        StartVelocityRange=(X=(Min=-20.000000,Max=20.000000),Y=(Min=-20.000000,Max=20.000000),Z=(Min=5.000000,Max=30.000000))
        VelocityLossRange=(X=(Min=0.500000,Max=0.500000),Y=(Min=0.500000,Max=0.500000))
        Name="SuperSpriteEmitter14"
    End Object
    Emitters(0)=SuperSpriteEmitter'SuperSpriteEmitter14'
    Begin Object Class=SuperSpriteEmitter Name=SuperSpriteEmitter16
		SecondsBeforeInactive=0.0
        UseColorScale=true
        ColorScale(0)=(RelativeTime=0.000000,Color=(B=50,G=150,R=200))
        ColorScale(1)=(RelativeTime=1.000000,Color=(B=150,G=50,R=255))
        MaxParticles=15
        RespawnDeadParticles=False
        StartLocationRange=(X=(Min=-30.000000,Max=30.000000),Y=(Min=-30.000000,Max=30.000000),Z=(Min=-30.000000,Max=30.000000))
        SpinParticles=True
		StartLocationOffset=(Z=-20.0)
        SpinsPerSecondRange=(X=(Max=0.200000))
        StartSpinRange=(X=(Max=1.000000))
        UseSizeScale=True
        UseRegularSizeScale=False
        SizeScale(0)=(RelativeTime=0.000000,RelativeSize=0.000000)
        SizeScale(1)=(RelativeTime=0.100000,RelativeSize=5.000000)
        SizeScale(2)=(RelativeTime=1.000000,RelativeSize=3.750000)
        StartSizeRange=(X=(Min=60.000000,Max=90.000000))
        InitialParticlesPerSecond=50.000000
        AutomaticInitialSpawning=False
        DrawStyle=PTDS_AlphaBlend
        Texture=Texture'nathans.Skins.expl1color'
        TextureUSubdivisions=1
        TextureVSubdivisions=4
        BlendBetweenSubdivisions=True
        LifetimeRange=(Min=3.500000,Max=5.000000)
        StartVelocityRange=(X=(Min=-20.000000,Max=20.000000),Y=(Min=-20.000000,Max=20.000000),Z=(Min=5.000000,Max=30.000000))
        VelocityLossRange=(X=(Min=0.500000,Max=0.500000),Y=(Min=0.500000,Max=0.500000))
        Name="SuperSpriteEmitter16"
    End Object
    Emitters(1)=SuperSpriteEmitter'SuperSpriteEmitter16'
    Begin Object Class=SpriteEmitter Name=SpriteEmitter27
		SecondsBeforeInactive=0.0
        Acceleration=(Z=-6000.000000)
        MaxParticles=80
        RespawnDeadParticles=False
        StartLocationRange=(X=(Min=-30.000000,Max=30.000000),Y=(Min=-30.000000,Max=30.000000),Z=(Min=-30.000000,Max=30.000000))
        SpinParticles=True
        SpinsPerSecondRange=(X=(Max=4.000000))
        StartSpinRange=(X=(Max=2.000000))
        UseSizeScale=True
        UseRegularSizeScale=False
        SizeScale(0)=(RelativeSize=1.000000)
        SizeScale(1)=(RelativeTime=1.000000)
        StartSizeRange=(X=(Min=5.000000,Max=15.000000))
        InitialParticlesPerSecond=300.000000
        AutomaticInitialSpawning=False
        DrawStyle=PTDS_AlphaBlend
        Texture=Texture'nathans.Skins.darkchunks'
        TextureUSubdivisions=1
        TextureVSubdivisions=2
        UseRandomSubdivision=True
        LifetimeRange=(Min=1.000000,Max=1.500000)
        StartVelocityRange=(X=(Min=-600.000000,Max=600.000000),Y=(Min=-600.000000,Max=600.000000),Z=(Max=1200.000000))
        Name="SpriteEmitter27"
    End Object
    Emitters(2)=SpriteEmitter'SpriteEmitter27'
	AutoDestroy=true
	Velocity=(Z=5000)
	Physics=PHYS_Projectile
	bBounce=true
    bCollideActors=true
    bCollideWorld=true
}
