class kP2Admin extends AccessControl
	config(kMods);

var config array<string> BannedNames;
var config string BannedNameError;

function PostBeginPlay()
{
	local BroadcastHandler BHcloset,NewBroad;

	BHcloset = Level.Game.BroadcastHandler;
	NewBroad=spawn(class'kVoteHandler');
	if (NewBroad != None)
	{
		Level.Game.BroadcastHandler = NewBroad;
		BHcloset.Destroy();
	}
}

function Inform(string S)
{
	local PlayerController pc;

	pc = PlayerController(Instigator.Controller);
	if (pc != None)
		pc.ClientMessage(s);
}

function Ban(string S, optional float minutes)
{
	local float seconds;
	local PlayerController P;
	local string IP;
	local int j;
	local kUnBanner UB;

	seconds = minutes*60;

	ForEach DynamicActors(class'PlayerController', P)
		if ( P.PlayerReplicationInfo.PlayerName~=S 
			&&	(NetConnection(P.Player)!=None) 
			&& !IsAdmin(P))
		{
			IP = P.GetPlayerNetworkAddress();
			if(CheckIPPolicy(IP))
			{
				IP = Left(IP, InStr(IP, ":"));
				Log("Adding IP Ban for: "$IP);
				for(j=0;j<50;j++)
					if( IPPolicies[j] == "" )
						break;
				if(j < 50)
					IPPolicies[j] = "DENY,"$IP;
				SaveConfig();

				if (Seconds > 0)
				{
					UB = Spawn(class'kUnBanner');
					UB.OurIP = IP;
					UB.SetTimer(seconds, false);
					Inform(S @ "has been banned for" @ minutes @ "minutes.");
				}
				else
					Inform(S @ "has been banned.");
			}
			Kick(P.PlayerReplicationInfo.PlayerName);
			return;
		}
	Inform(S @ "is not a valid player.");
}

function UnBan(string S)
{
	local int i;

	i = GetIPPolicy(S);
	if (i != -1)
	{
		IPPolicies[i] = "";
		Inform(S @ "has been unbanned.");
	}
	else
		Inform(S @ "was not found in the ban list.");
}

function int GetIPPolicy(string Address)
{
	local int i, j, LastMatchingPolicy;
	local string Policy, Mask;
	local bool bAcceptAddress, bAcceptPolicy;
	
	LastMatchingPolicy = -1;

	// strip port number
	j = InStr(Address, ":");
	if(j != -1)
		Address = Left(Address, j);

	bAcceptAddress = True;
	for(i=0; i<50 && IPPolicies[i] != ""; i++)
	{
		j = InStr(IPPolicies[i], ",");
		if(j==-1)
			continue;
		Policy = Left(IPPolicies[i], j);
		Mask = Mid(IPPolicies[i], j+1);
		if(Policy ~= "ACCEPT") 
			bAcceptPolicy = True;
		else if(Policy ~= "DENY") 
			bAcceptPolicy = False;
		else
			continue;

		j = InStr(Mask, "*");
		if(j != -1)
		{
			if(Left(Mask, j) == Left(Address, j))
			{
				bAcceptAddress = bAcceptPolicy;
				if (!bAcceptPolicy)
					LastMatchingPolicy = i;
			}
		}
		else
		{
			if(Mask == Address)
			{
				bAcceptAddress = bAcceptPolicy;
				if (!bAcceptPolicy)
					LastMatchingPolicy = i;
			}
		}
	}

	return LastMatchingPolicy;
}

event PreLogin
(
	string Options,
	string Address,
	out string Error,
	out string FailCode,
	bool bSpectator
)
{
	local string InName;
	local int i;

	Super.PreLogin(Options, Address, Error, FailCode, bSpectator);

	InName     = Left(Level.Game.ParseOption ( Options, "Name"), 20);
	for (i=0; i<BannedNames.Length; i++)
	{
		log("Comparing" @ InName @ "to" @ BannedNames[i]);
		if (BannedNames[i] ~= InName)
			Error = BannedNameError;
	}

}

defaultproperties
{
	BannedNames[0]="Player"
	BannedNameError="Change your name, stupid."
	AdminClass=class'kAdmin'
}