class kShovelFight extends xMutator;

// Base mutator for weapon substitution.
// Easy to make your own weapon subs... all shovel if you want, or all WMD, or whatever.

var class<P2Weapon> NewWeapon;
var class<P2Weapon> NewWeaponSS;

///////////////////////////////////////////////////////////////////////////////
// Replace weapons with foo
///////////////////////////////////////////////////////////////////////////////
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	// Destroy all weapon and ammo pickups
	if (P2WeaponPickup(Other) != None)
		return false;
	if (P2AmmoPickup(Other) != None)
		return false;

	// Replace default pistol with shovel
	if (PistolWeaponSS(Other) != None && P2Pawn(Other.Owner) != None)
		return (P2Pawn(Other.Owner).CreateInventoryByClass(NewWeaponSS) == None);
	if (PistolWeapon(Other) != None && P2Pawn(Other.Owner) != None)
		return (P2Pawn(Other.Owner).CreateInventoryByClass(NewWeapon) == None);

	// Remove also from cycling pickups
	if(MultiPickup(Other) != None)
	{
		MultiPickup(Other).SwapClass(class'CowHeadPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'ScissorsPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'LauncherPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'LauncherAmmoPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'MachinegunPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'MachinegunAmmoPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'MolotovPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'RiflePickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'RifleAmmoPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'ShotgunPickup', class'DonutPickup');
		MultiPickup(Other).SwapClass(class'ShotgunAmmoPickup', class'DonutPickup');
	}

	return true;
}

defaultproperties
{
	GroupName="kWeaponPickupReplacement"
	FriendlyName="Shovel Fight"
	Description="All players start with shovels, no other weapons available"

	NewWeapon=class'ShovelWeapon'
	NewWeaponSS=class'ShovelWeaponSS'
}
