///////////////////////////////////////////////////////////////////////////////
// kWeaponSub.uc
// postaldude@cox.net
//
// Change all weapons to foo
//
///////////////////////////////////////////////////////////////////////////////
class kWeaponSub extends xMutator;

// Base mutator for weapon substitution.
// Easy to make your own weapon subs... all shovel if you want, or all WMD, or whatever.

var class<P2WeaponPickup> NewWeaponPickup;
var string ReplacementWeapon;

var class<P2AmmoPickup> NewAmmoPickup;
var string ReplacementAmmo;

var class<P2Weapon> NewWeapon;
var class<P2Weapon> NewWeaponSS;

var class<P2AmmoInv> NewAmmoInv;

///////////////////////////////////////////////////////////////////////////////
// Replace weapons with foo
///////////////////////////////////////////////////////////////////////////////
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	// Check normal pickups
	if (P2WeaponPickup(Other) != None && Other.Class != NewWeaponPickup)
		return !ReplaceWith(Other, ReplacementWeapon);
	if (P2AmmoPickup(Other) != None && Other.Class != NewAmmoPickup)
		return !ReplaceWith(Other, ReplacementAmmo);

	// Replace default pistol with foo
	if (PistolWeaponSS(Other) != None && P2Pawn(Other.Owner) != None)
		return (P2Pawn(Other.Owner).CreateInventoryByClass(NewWeaponSS) == None);
	if (PistolWeapon(Other) != None && P2Pawn(Other.Owner) != None)
		return (P2Pawn(Other.Owner).CreateInventoryByClass(NewWeapon) == None);

	// Remove also from cycling pickups
	if(MultiPickup(Other) != None)
	{
		MultiPickup(Other).SwapClass(class'CowHeadPickup', NewWeaponPickup);
		MultiPickup(Other).SwapClass(class'ScissorsPickup', NewWeaponPickup);
		MultiPickup(Other).SwapClass(class'LauncherPickup', NewWeaponPickup);
		MultiPickup(Other).SwapClass(class'LauncherAmmoPickup', NewAmmoPickup);
		MultiPickup(Other).SwapClass(class'MachinegunPickup', NewWeaponPickup);
		MultiPickup(Other).SwapClass(class'MachinegunAmmoPickup', NewAmmoPickup);
		MultiPickup(Other).SwapClass(class'MolotovPickup', NewWeaponPickup);
		MultiPickup(Other).SwapClass(class'RiflePickup', NewWeaponPickup);
		MultiPickup(Other).SwapClass(class'RifleAmmoPickup', NewAmmoPickup);
		MultiPickup(Other).SwapClass(class'ShotgunPickup', NewWeaponPickup);
		MultiPickup(Other).SwapClass(class'ShotgunAmmoPickup', NewAmmoPickup);
	}

	// Alter max ammo of Grenades
	if (P2AmmoInv(Other) != None)
		if (P2AmmoInv(Other).Class == NewAmmoInv)
			P2AmmoInv(Other).MaxAmmoMP = P2AmmoInv(Other).Default.MaxAmmoMP * 3;

	return true;
}

defaultproperties
{
	GroupName="kWeaponPickupReplacement"
	FriendlyName="Weapon Substitution"
	Description="Substitutes all weapons in the game with foo."

	NewWeaponPickup=class'P2WeaponPickup'
	ReplacementWeapon="Postal2Game.P2WeaponPickup"

	NewAmmoPickup=class'P2AmmoPickup'
	ReplacementAmmo="Postal2Game.P2AmmoPickup"

	NewWeapon=class'P2Weapon'
	NewWeaponSS=class'P2Weapon'

	NewAmmoInv=class'P2AmmoInv'
}
